$conf[0] = "ROW2 PD4 PC0 ROW1";
$conf[1] = "COL4 PC5 PC1 COL8";
$conf[2] = "COL3 PC4 PC2 ROW3";
$conf[3] = "COL2 PC3 PB1 ROW4";
$conf[4] = "ROW5 PD5 PB5 COL7";
$conf[5] = "ROW6 PD6 PB4 COL6";
$conf[6] = "COL1 PD7 PB3 COL5"; 
$conf[7] = "ROW8 PB0 PB2 ROW7";

for ($i=0; $i < 8; $i++) {
	@in = split(/[ \t]+/, $conf[$i]);
	$pin{"$in[0]"} = $in[1];
	$pin{"$in[3]"} = $in[2];
}

for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	printf("#define\tROW$i\t$x\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	printf("#define\tCOL$i\t$x\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	$y = substr($x,1,1);
	printf("#define\tROW$i"."_PORT\tPORT$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	$y = substr($x,1,1);
	printf("#define\tROW$i"."_DDR\tDDR$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"ROW$i"};
	$y = substr($x,1,1);
	printf("#define\tROW$i"."_PIN\tPIN$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	$y = substr($x,1,1);
	printf("#define\tCOL$i"."_PORT\tPORT$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	$y = substr($x,1,1);
	printf("#define\tCOL$i"."_DDR\tDDR$y\n");
}
print("\n");
for ($i=1; $i<= 8; $i++) {
	$x = $pin{"COL$i"};
	$y = substr($x,1,1);
	printf("#define\tCOL$i"."_PIN\tPIN$y\n");
}
print("\n");
